module Practical6 where

import Data.List

-- The practice problems below weren't covered in the practical,
-- but you can attempt them to improve your list monad skills.
-- The odd-numbered ones come with solutions you can study as well.
-- - Zoltan

{-
Task 1.
A cryptarithm is a mathematical puzzle where the digits in a sum
are replaced by letters, subject to the following rules:

1. Different letters stand for different digit.
2. No number has 0 as its leading digit.

To solve the cryptarithm, you have to find the number
represented by each letter.
Solve the cryptarithm below. Use the List monad.

  AB
+ BC
----
 BCB 

-}

solution1 :: [(Integer,Integer,Integer)]
solution1 = 
  [1..9]          >>= \a ->
  [1..9] \\ [a]   >>= \b ->
  [0..9] \\ [a,b] >>= \c ->
  if (10*a + b + 10*b + c /= 100*b+10*c+b)
    then []
    else return (a,b,c)

{-
Task 2.
Each card in a deck has a rank between 1 (Ace) and 13 (King)
and a Suit (Club, Diamond, Heart, Spade).
Use the list monad to generate all cards in a deck.
-}


{-
Task 3.
Suppose you're on a game show, and you're given the choice between
two closed doors. Each door has a sign on it.
The sign on the left door says:
  "Behind this door is the goat, behind the other is the car."
The sign on the right door says:
  "Behind one of these doors is the goat, behind the other is the car."

The host of the game show tells you that exactly one of the signs is
correct. You know that the host is telling the truth.

You can open one door. You'll get whatever is behind it as
your prize.

Which door should you open to get the car?
Use the list monad to find out!
-}

data Room = Goat | Car deriving (Show, Eq)

-- when is the left sign true?
signL :: Room -> Room -> Bool
signL l r = (l == Goat) && (r == Car)

-- when is the right sign true?
signR :: Room -> Room -> Bool
signR l r = or [(l == Goat) && (r == Car), (l == Car) && (r == Goat)]

solution3 :: [(Room,Room)]
solution3 =
  [Goat, Car] >>= \l ->
  [Goat, Car] >>= \r ->
  if or [signL l r && not (signR l r), not (signL l r) && signR l r]
      then return (l,r)
      else []

{-
Task 4.
Suppose you're on yet another game show, and you're given the choice between
two closed doors. Each door has a sign on it.
The sign on the left door says:
  "Behind this door is a goat, behind the other is a car."
The sign on the right door says:
  "Behind one of these doors is a goat, behind the other is a car."

The host of the game show tells you that the prize behind each door
was chosen independently, by flipping a coin: head -> Goat, tail -> Car.
The host also tells you that at most one of the signs is
correct. You know that the host is telling the truth.

Which door should you open to maximize the probability of
winning the car? Use the list monad to find out.
-}
